<?php

namespace App\Filament\Exports;

use App\Models\InvoiceMaster;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class InvoiceMasterExporter extends Exporter
{
    protected static ?string $model = InvoiceMaster::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('receiving_plant')
            ->label('Receiving Plant'),
            ExportColumn::make('receiving_plant_name')
            ->label('Receiving Plant Name'),
            ExportColumn::make('transit_days')
            ->label('Transit Days'),
            ExportColumn::make('transport_name')
            ->label('Transport Name'),
            ExportColumn::make('created_at')
            ->label('Created At'),
            ExportColumn::make('updated_at')
            ->label('Updated At'),
            ExportColumn::make('created_by')
            ->label('Created By'),
            ExportColumn::make('updated_by')
            ->label('Updated By'),
            ExportColumn::make('deleted_at')
            ->label('Deleted At')
            ->enabledByDefault(false),

        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your invoice master export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
